package info.textgrid.lab.collatex.ui;

import info.textgrid.lab.collatex.CollateXPlugin;

import java.text.MessageFormat;
import java.util.Set;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.swt.dnd.ByteArrayTransfer;
import org.eclipse.swt.dnd.TransferData;
import org.eclipse.ui.statushandlers.StatusManager;

import com.google.common.base.Joiner;

import eu.interedition.collatex.Token;

/**
 * Used for drag & drop operations of tokens. Still rather suboptimal
 * implementation.
 */
public class WitnessTransfer extends ByteArrayTransfer {

	@Override
	protected void javaToNative(final Object object,
			final TransferData transferData) {
		// if (isSupportedType(transferData))
		// super.javaToNative(new byte[0], transferData);
		// else
		// super.javaToNative(object, transferData);
	}

	@Override
	protected Object nativeToJava(final TransferData transferData) {
		// super.nativeToJava(transferData);
		return getTokens();
	}

	private static final String NAME = WitnessTransfer.class.getCanonicalName();
	private static final int ID = registerType(NAME);
	private static WitnessTransfer INSTANCE;

	private Set<Token> tokens;

	public Set<Token> getTokens() {
		return tokens;
	}

	public void setTokens(final Set<Token> tokens) {
		this.tokens = tokens;
		// XXX Debugging:
		StatusManager.getManager().handle(
				new Status(IStatus.INFO, CollateXPlugin.PLUGIN_ID,
						"WitnessTransfer.setTokens: " //$NON-NLS-1$
						+ Joiner.on(", ").join(tokens)), //$NON-NLS-1$
						StatusManager.LOG);
	}

	private WitnessTransfer() {
	}

	@Override
	protected String[] getTypeNames() {
		return new String[] { NAME };
	}

	@Override
	protected int[] getTypeIds() {
		return new int[] { ID };
	}

	public static synchronized WitnessTransfer getInstance() {
		if (INSTANCE == null)
			INSTANCE = new WitnessTransfer();
		System.err.println(MessageFormat.format(
				"Yo! Returning a WitnessTransfer: {0}", INSTANCE)); //$NON-NLS-1$
		return INSTANCE;
	}

}
